<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: OV7670.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">OV7670.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * OV7670.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Jun 10, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef CPP_UTILS_OV7670_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define CPP_UTILS_OV7670_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;I2C.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;driver/ledc.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#define OV7670_REG_GAIN   (0x00)</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define OV7670_REG_BLUE   (0x01)</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define OV7670_REG_RED    (0x02)</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define OV7670_REG_VREF   (0x03)</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define OV7670_REG_COM1   (0x04)</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#define OV7670_REG_BAVE   (0x05)</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define OV7670_REG_GbAVE  (0x06)</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#define OV7670_REG_AECHH  (0x07)</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#define OV7670_REG_RAVE   (0x08)</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define OV7670_REG_COM2   (0x09)</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#define OV7670_REG_PID    (0x0A)</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define OV7670_REG_VER    (0x0B)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define OV7670_REG_COM3   (0x0C)</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#define OV7670_REG_COM4   (0x0D)</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define OV7670_REG_COM5   (0x0E)</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#define OV7670_REG_COM6   (0x0F)</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#define OV7670_REG_AECH   (0x10)</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#define OV7670_REG_CLKRC  (0x11)</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#define OV7670_REG_COM7   (0x12)</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#define OV7670_REG_COM8   (0x13)</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#define OV7670_REG_COM9   (0x14)</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#define OV7670_REG_COM10  (0x15)</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define OV7670_REG_HSTART (0x17)</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#define OV7670_REG_HSTOP  (0x18)</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#define OV7670_REG_VSTRT  (0x19)</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#define OV7670_REG_VSTOP  (0x1a)</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#define OV7670_REG_PSHFT  (0x1b)</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#define OV7670_REG_MIDH   (0x1c)</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#define OV7670_REG_MIDL   (0x1d)</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#define OV7670_REG_MFVP   (0x1e)</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#define OV7670_REG_LAEC   (0x1f)</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#define OV7670_REG_ADCCTR0 (0x20)</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#define OV7670_REG_ADCCTR1 (0x21)</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#define OV7670_REG_ADCCTR2 (0x22)</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#define OV7670_REG_ADCCTR3 (0x23)</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#define OV7670_REG_AEW    (0x24)</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#define OV7670_REG_AEB    (0x25)</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#define OV7670_REG_VPT    (0x26)</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#define OV7670_REG_BBIAS  (0x27)</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#define OV7670_REG_GbBIAS (0x28)</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#define OV7670_REG_RSVD   (0x00)</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#define OV7670_REG_EXHCH  (0x2a)</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#define OV7670_REG_EXHCL  (0x2b)</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#define OV7670_REG_RBIAS  (0x2c)</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#define OV7670_REG_ADVFL  (0x2d)</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#define OV7670_REG_ADVFH  (0x2e)</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#define OV7670_REG_YAVE   (0x2f)</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#define OV7670_REG_HSYST  (0x30)</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#define OV7670_REG_HSYEN  (0x31)</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#define OV7670_REG_HREF   (0x32)</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="preprocessor">#define OV7670_REG_CHLF   (0x33)</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="preprocessor">#define OV7670_REG_ARBLM  (0x34)</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="preprocessor">#define OV7670_REG_ADC    (0x37)</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">#define OV7670_REG_ACOM   (0x38)</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">#define OV7670_REG_OFON   (0x39)</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#define OV7670_REG_TSLB   (0x3a)</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#define OV7670_REG_COM11  (0x3b)</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="preprocessor">#define OV7670_REG_COM12  (0x3c)</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="preprocessor">#define OV7670_REG_COM13  (0x3d)</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#define OV7670_REG_COM14  (0x3e)</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="preprocessor">#define OV7670_REG_EDGE   (0x3f)</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="preprocessor">#define OV7670_REG_COM15  (0x40)</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="preprocessor">#define OV7670_REG_COM16  (0x41)</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="preprocessor">#define OV7670_REG_COM17  (0x42)</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC1  (0x43)</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC2  (0x44)</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC3  (0x45)</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC4  (0x46)</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC5  (0x47)</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBC6  (0x48)</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#define OV7670_REG_RSVD   (0x00)</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="preprocessor">#define OV7670_REG_REG4B  (0x4b)</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#define OV7670_REG_DNSTH  (0x4c)</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="preprocessor">#define OV7670_REG_RSVD   (0x00)</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX1   (0x4f)</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX2   (0x50)</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX3   (0x51)</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX4   (0x52)</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX5   (0x53)</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="preprocessor">#define OV7670_REG_MTX6   (0x54)</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="preprocessor">#define OV7670_REG_BRIGHT (0x55)</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="preprocessor">#define OV7670_REG_CONTRAS (0x56)</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="preprocessor">#define OV7670_REG_CONTRAS_CENTER (0x57)</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="preprocessor">#define OV7670_REG_MTXS  (0x58)</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#define OV7670_REG_RSVD  (0x00)</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC1  (0x62)</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC2  (0x63)</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC3  (0x64)</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC4  (0x65)</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC5  (0x66)</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="preprocessor">#define OV7670_REG_MANU  (0x67)</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#define OV7670_REG_MANV  (0x68)</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="preprocessor">#define OV7670_REG_GFIX  (0x69)</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">#define OV7670_REG_GGAIN (0x6a)</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="preprocessor">#define OV7670_REG_DBLV  (0x6b)</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBCTR3 (0x6c)</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBCTR2 (0x6d)</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBCTR1 (0x6e)</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#define OV7670_REG_AWBCTR0 (0x6f)</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#define OV7670_REG_SCALING_XSC      (0x70)</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="preprocessor">#define OV7670_REG_SCALING_YSC      (0x71)</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="preprocessor">#define OV7670_REG_SCALING_DCWCTR   (0x72)</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="preprocessor">#define OV7670_REG_SCALING_PCLK_DIV (0x73)</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#define OV7670_REG_REG74   (0x74)</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="preprocessor">#define OV7670_REG_REG75   (0x75)</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="preprocessor">#define OV7670_REG_REG76   (0x76)</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="preprocessor">#define OV7670_REG_REG77   (0x77)</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM1    (0x7a)</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM2    (0x7b)</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM3    (0x7c)</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM4    (0x7d)</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM5    (0x7e)</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM6    (0x7f)</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM7    (0x80)</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM8    (0x81)</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM9    (0x82)</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM10   (0x83)</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM11   (0x84)</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM12   (0x85)</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM13   (0x86)</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM14   (0x87)</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="preprocessor">#define OV7670_REG_GAM15   (0x88)</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="preprocessor">#define OV7670_REG_RSVD    (0x00)</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="preprocessor">#define OV7670_REG_DM_LNL  (0x92)</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="preprocessor">#define OV7670_REG_DML_LNH (0x93)</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC6    (0x94)</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="preprocessor">#define OV7670_REG_LCC7    (0x95)</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="preprocessor">#define OV7670_REG_BD50ST  (0x9d)</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="preprocessor">#define OV7670_REG_BD60ST  (0x9e)</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="preprocessor">#define OV7670_REG_STR_OPT (0xAC)</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="preprocessor">#define OV7670_REG_STR_R   (0xAD)</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="preprocessor">#define OV7670_REG_STR_G   (0xAE)</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#define OV7670_REG_STR_B   (0xAF)</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="preprocessor">#define OV7670_REG_THL_ST  (0xB3)</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="preprocessor">#define OV7670_REG_THL_DLT (0xB5)</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#define OV7670_REG_AD_CHB  (0xBE)</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#define OV7670_REG_AD_CHR  (0xBF)</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="preprocessor">#define OV7670_REG_AD_CHGb (0xC0)</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#define OV7670_REG_AD_CHGr (0xC1)</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="preprocessor">#define OV7670_REG_SATCTR  (0xC9)</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">// COM7[2] and COM7[0]</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="preprocessor">#define OV7670_FORMAT_YUV (0b00)</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="preprocessor">#define OV7670_FORMAT_RGB (0b10)</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="preprocessor">#define OV7670_FORMAT_RGB_RGB_NORMAL (0b00)</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="preprocessor">#define OV7670_FORMAT_RGB_RGB_565    (0b01)</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="preprocessor">#define OV7670_FORMAT_RGB_RGB_555    (0b11)</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">// SCALING_XSC[7] and SCALINT_YSC[7]</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="preprocessor">#define OV7670_TESTPATTERN_NONE      (0b00)</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="preprocessor">#define OV7670_TESTPATTERN_SHIFT_1   (0b01)</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="preprocessor">#define OV7670_TESTPATTERN_BAR_8     (0b10)</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="preprocessor">#define OV7670_TESTPATTERN_GRAY_FADE (0b11)</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="structcamera__config__t.html">  168</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a9935ac510209beb325061fd0ed30823d">  169</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a9935ac510209beb325061fd0ed30823d">pin_reset</a>;          </div><div class="line"><a name="l00170"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#adae554b70623090ed02ab03d5385d884">  170</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#adae554b70623090ed02ab03d5385d884">pin_xclk</a>;           </div><div class="line"><a name="l00171"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a1d7e6feea488721346d23bf6ebb87449">  171</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a1d7e6feea488721346d23bf6ebb87449">pin_sscb_sda</a>;       </div><div class="line"><a name="l00172"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a4c3e62089d1ba10dc5489dbc82f4047a">  172</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a4c3e62089d1ba10dc5489dbc82f4047a">pin_sscb_scl</a>;       </div><div class="line"><a name="l00173"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a0b265296822d4612b67b6a1ffad9e756">  173</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a0b265296822d4612b67b6a1ffad9e756">pin_d7</a>;             </div><div class="line"><a name="l00174"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a5a222371493270fb4b4bcf68bc417100">  174</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a5a222371493270fb4b4bcf68bc417100">pin_d6</a>;             </div><div class="line"><a name="l00175"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a3229380194c2b360713d7240886ae9ed">  175</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a3229380194c2b360713d7240886ae9ed">pin_d5</a>;             </div><div class="line"><a name="l00176"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a540b14d31f869b98b7e01ee8743e2ffd">  176</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a540b14d31f869b98b7e01ee8743e2ffd">pin_d4</a>;             </div><div class="line"><a name="l00177"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a4bda847f01d013e1c9d213b967ba506f">  177</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a4bda847f01d013e1c9d213b967ba506f">pin_d3</a>;             </div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a43d5891aa4f0356a4b311cd5ecb1cfc6">  178</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a43d5891aa4f0356a4b311cd5ecb1cfc6">pin_d2</a>;             </div><div class="line"><a name="l00179"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a3bde2c6474cab22a14d1b6ef3f103d9c">  179</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a3bde2c6474cab22a14d1b6ef3f103d9c">pin_d1</a>;             </div><div class="line"><a name="l00180"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#aa7fcc08f51ca08c849d3d7cfc54cbc12">  180</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#aa7fcc08f51ca08c849d3d7cfc54cbc12">pin_d0</a>;             </div><div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a3c3b0d95798353d4917d93a68e56a2c2">  181</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a3c3b0d95798353d4917d93a68e56a2c2">pin_vsync</a>;          </div><div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#ab9dd487279954adb8421992423e46cc7">  182</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#ab9dd487279954adb8421992423e46cc7">pin_href</a>;           </div><div class="line"><a name="l00183"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a64f2ef831ff4645f82f69ba16542764a">  183</a></span>&#160;    gpio_num_t <a class="code" href="structcamera__config__t.html#a64f2ef831ff4645f82f69ba16542764a">pin_pclk</a>;           </div><div class="line"><a name="l00185"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#af198ac8cc343a51b0aa24629f71796fc">  185</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structcamera__config__t.html#af198ac8cc343a51b0aa24629f71796fc">xclk_freq_hz</a>;       </div><div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#aaa321aa2f9ae05a8684101e8aee35045">  186</a></span>&#160;    ledc_timer_t <a class="code" href="structcamera__config__t.html#aaa321aa2f9ae05a8684101e8aee35045">ledc_timer</a>;        </div><div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="structcamera__config__t.html#a4a392588ba015497f3491ddf2bbbcd85">  187</a></span>&#160;    ledc_channel_t <a class="code" href="structcamera__config__t.html#a4a392588ba015497f3491ddf2bbbcd85">ledc_channel</a>;    </div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;} <a class="code" href="structcamera__config__t.html">camera_config_t</a>;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="classOV7670.html">  190</a></span>&#160;<span class="keyword">class </span><a class="code" href="classOV7670.html">OV7670</a> {</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <a class="code" href="classOV7670.html">OV7670</a>();</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classOV7670.html">OV7670</a>();</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classOV7670.html#acaa582805f38bc41c5812888fb965197">init</a>(<a class="code" href="structcamera__config__t.html">camera_config_t</a> cameraConfig);</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classOV7670.html#a9d954bb72a8a1794fb76fee07e5d64bf">dump</a>();</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classOV7670.html#a7148b44da5949ae39468c8c31cf6092f">reset</a>();</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keywordtype">void</span> setFormat(uint8_t value);</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keywordtype">void</span> setRGBFormat(uint8_t value);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordtype">void</span> setTestPattern(uint8_t value);</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keywordtype">void</span> resetCamera();</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    uint8_t readRegister(uint8_t reg);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keywordtype">void</span> writeRegister(uint8_t reg, uint8_t value);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <a class="code" href="structcamera__config__t.html">camera_config_t</a> m_cameraConfig;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <a class="code" href="classI2C.html">I2C</a>* m_i2c;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;};</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* CPP_UTILS_OV7670_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="structcamera__config__t_html_a3c3b0d95798353d4917d93a68e56a2c2"><div class="ttname"><a href="structcamera__config__t.html#a3c3b0d95798353d4917d93a68e56a2c2">camera_config_t::pin_vsync</a></div><div class="ttdeci">gpio_num_t pin_vsync</div><div class="ttdef"><b>Definition:</b> OV7670.h:181</div></div>
<div class="ttc" id="structcamera__config__t_html_a5a222371493270fb4b4bcf68bc417100"><div class="ttname"><a href="structcamera__config__t.html#a5a222371493270fb4b4bcf68bc417100">camera_config_t::pin_d6</a></div><div class="ttdeci">gpio_num_t pin_d6</div><div class="ttdef"><b>Definition:</b> OV7670.h:174</div></div>
<div class="ttc" id="classOV7670_html_a7148b44da5949ae39468c8c31cf6092f"><div class="ttname"><a href="classOV7670.html#a7148b44da5949ae39468c8c31cf6092f">OV7670::reset</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">Reset the camera. Toggle the reset pin on the camera.</div><div class="ttdef"><b>Definition:</b> OV7670.cpp:512</div></div>
<div class="ttc" id="structcamera__config__t_html_a9935ac510209beb325061fd0ed30823d"><div class="ttname"><a href="structcamera__config__t.html#a9935ac510209beb325061fd0ed30823d">camera_config_t::pin_reset</a></div><div class="ttdeci">gpio_num_t pin_reset</div><div class="ttdef"><b>Definition:</b> OV7670.h:169</div></div>
<div class="ttc" id="structcamera__config__t_html_a540b14d31f869b98b7e01ee8743e2ffd"><div class="ttname"><a href="structcamera__config__t.html#a540b14d31f869b98b7e01ee8743e2ffd">camera_config_t::pin_d4</a></div><div class="ttdeci">gpio_num_t pin_d4</div><div class="ttdef"><b>Definition:</b> OV7670.h:176</div></div>
<div class="ttc" id="structcamera__config__t_html_aa7fcc08f51ca08c849d3d7cfc54cbc12"><div class="ttname"><a href="structcamera__config__t.html#aa7fcc08f51ca08c849d3d7cfc54cbc12">camera_config_t::pin_d0</a></div><div class="ttdeci">gpio_num_t pin_d0</div><div class="ttdef"><b>Definition:</b> OV7670.h:180</div></div>
<div class="ttc" id="structcamera__config__t_html_af198ac8cc343a51b0aa24629f71796fc"><div class="ttname"><a href="structcamera__config__t.html#af198ac8cc343a51b0aa24629f71796fc">camera_config_t::xclk_freq_hz</a></div><div class="ttdeci">int xclk_freq_hz</div><div class="ttdef"><b>Definition:</b> OV7670.h:185</div></div>
<div class="ttc" id="classOV7670_html_acaa582805f38bc41c5812888fb965197"><div class="ttname"><a href="classOV7670.html#acaa582805f38bc41c5812888fb965197">OV7670::init</a></div><div class="ttdeci">void init(camera_config_t cameraConfig)</div><div class="ttdoc">Initialize the camera.</div><div class="ttdef"><b>Definition:</b> OV7670.cpp:370</div></div>
<div class="ttc" id="structcamera__config__t_html_aaa321aa2f9ae05a8684101e8aee35045"><div class="ttname"><a href="structcamera__config__t.html#aaa321aa2f9ae05a8684101e8aee35045">camera_config_t::ledc_timer</a></div><div class="ttdeci">ledc_timer_t ledc_timer</div><div class="ttdef"><b>Definition:</b> OV7670.h:186</div></div>
<div class="ttc" id="structcamera__config__t_html_a1d7e6feea488721346d23bf6ebb87449"><div class="ttname"><a href="structcamera__config__t.html#a1d7e6feea488721346d23bf6ebb87449">camera_config_t::pin_sscb_sda</a></div><div class="ttdeci">gpio_num_t pin_sscb_sda</div><div class="ttdef"><b>Definition:</b> OV7670.h:171</div></div>
<div class="ttc" id="structcamera__config__t_html_a3229380194c2b360713d7240886ae9ed"><div class="ttname"><a href="structcamera__config__t.html#a3229380194c2b360713d7240886ae9ed">camera_config_t::pin_d5</a></div><div class="ttdeci">gpio_num_t pin_d5</div><div class="ttdef"><b>Definition:</b> OV7670.h:175</div></div>
<div class="ttc" id="structcamera__config__t_html_ab9dd487279954adb8421992423e46cc7"><div class="ttname"><a href="structcamera__config__t.html#ab9dd487279954adb8421992423e46cc7">camera_config_t::pin_href</a></div><div class="ttdeci">gpio_num_t pin_href</div><div class="ttdef"><b>Definition:</b> OV7670.h:182</div></div>
<div class="ttc" id="structcamera__config__t_html_a4bda847f01d013e1c9d213b967ba506f"><div class="ttname"><a href="structcamera__config__t.html#a4bda847f01d013e1c9d213b967ba506f">camera_config_t::pin_d3</a></div><div class="ttdeci">gpio_num_t pin_d3</div><div class="ttdef"><b>Definition:</b> OV7670.h:177</div></div>
<div class="ttc" id="structcamera__config__t_html_a3bde2c6474cab22a14d1b6ef3f103d9c"><div class="ttname"><a href="structcamera__config__t.html#a3bde2c6474cab22a14d1b6ef3f103d9c">camera_config_t::pin_d1</a></div><div class="ttdeci">gpio_num_t pin_d1</div><div class="ttdef"><b>Definition:</b> OV7670.h:179</div></div>
<div class="ttc" id="structcamera__config__t_html_a43d5891aa4f0356a4b311cd5ecb1cfc6"><div class="ttname"><a href="structcamera__config__t.html#a43d5891aa4f0356a4b311cd5ecb1cfc6">camera_config_t::pin_d2</a></div><div class="ttdeci">gpio_num_t pin_d2</div><div class="ttdef"><b>Definition:</b> OV7670.h:178</div></div>
<div class="ttc" id="structcamera__config__t_html_a0b265296822d4612b67b6a1ffad9e756"><div class="ttname"><a href="structcamera__config__t.html#a0b265296822d4612b67b6a1ffad9e756">camera_config_t::pin_d7</a></div><div class="ttdeci">gpio_num_t pin_d7</div><div class="ttdef"><b>Definition:</b> OV7670.h:173</div></div>
<div class="ttc" id="classOV7670_html_a9d954bb72a8a1794fb76fee07e5d64bf"><div class="ttname"><a href="classOV7670.html#a9d954bb72a8a1794fb76fee07e5d64bf">OV7670::dump</a></div><div class="ttdeci">void dump()</div><div class="ttdoc">Dump the settings.</div><div class="ttdef"><b>Definition:</b> OV7670.cpp:269</div></div>
<div class="ttc" id="structcamera__config__t_html"><div class="ttname"><a href="structcamera__config__t.html">camera_config_t</a></div><div class="ttdef"><b>Definition:</b> OV7670.h:168</div></div>
<div class="ttc" id="classI2C_html"><div class="ttname"><a href="classI2C.html">I2C</a></div><div class="ttdoc">Interface to I2C functions.</div><div class="ttdef"><b>Definition:</b> I2C.h:19</div></div>
<div class="ttc" id="classOV7670_html"><div class="ttname"><a href="classOV7670.html">OV7670</a></div><div class="ttdef"><b>Definition:</b> OV7670.h:190</div></div>
<div class="ttc" id="structcamera__config__t_html_a64f2ef831ff4645f82f69ba16542764a"><div class="ttname"><a href="structcamera__config__t.html#a64f2ef831ff4645f82f69ba16542764a">camera_config_t::pin_pclk</a></div><div class="ttdeci">gpio_num_t pin_pclk</div><div class="ttdef"><b>Definition:</b> OV7670.h:183</div></div>
<div class="ttc" id="structcamera__config__t_html_adae554b70623090ed02ab03d5385d884"><div class="ttname"><a href="structcamera__config__t.html#adae554b70623090ed02ab03d5385d884">camera_config_t::pin_xclk</a></div><div class="ttdeci">gpio_num_t pin_xclk</div><div class="ttdef"><b>Definition:</b> OV7670.h:170</div></div>
<div class="ttc" id="structcamera__config__t_html_a4a392588ba015497f3491ddf2bbbcd85"><div class="ttname"><a href="structcamera__config__t.html#a4a392588ba015497f3491ddf2bbbcd85">camera_config_t::ledc_channel</a></div><div class="ttdeci">ledc_channel_t ledc_channel</div><div class="ttdef"><b>Definition:</b> OV7670.h:187</div></div>
<div class="ttc" id="structcamera__config__t_html_a4c3e62089d1ba10dc5489dbc82f4047a"><div class="ttname"><a href="structcamera__config__t.html#a4c3e62089d1ba10dc5489dbc82f4047a">camera_config_t::pin_sscb_scl</a></div><div class="ttdeci">gpio_num_t pin_sscb_scl</div><div class="ttdef"><b>Definition:</b> OV7670.h:172</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
